plugins['pausedsince'] = (function() {

    var pause_status_template  = pluginconfig['pausedsince']['pause_status_template'][''];
    var saved_presence_var={};

    return { 

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~pausedsince" + "|" + hash + "\" />";
            sendcommand();
        },

        setLang: function() {
            //$('#pausedsince_element').attr('title',lang.pausedsincestring);
            var passedvar = saved_presence_var;
            if(!'PAUSED_STATUS' in passedvar) {
                passedvar['PAUSED_STATUS']='';
            } else {
                // initial presence reason comes before lang, so check lang translation and use it if available
                if (lang.hasOwnProperty(passedvar['PAUSED_STATUS'])) {
                    passedvar['PAUSED_STATUS'] = lang[passedvar['PAUSED_STATUS']];
                }
            }
            passedvar['LANG']=lang;
            passedvar['PAUSED_COLOR']= '';
            passedvar['PAUSED_STATUS']= '';
            passedvar['PAUSED_TIMER']='<span id="tickpause_pausedsince">00:00:00</span>';
            passedvar['NAME']=botonitos[myposition].LABEL;

            dust.render("pausedsincepausestatus", passedvar, function(err, out) {
                $('#pausedsince_paused_status').html(out);
            });

            if($('#pause_status_template').length==0) {
                // not yet rendered as we did not receive lang
                saved_presence_var = JSON.parse(JSON.stringify(passedvar));
            }
        },
        callback_getvar: function(nro,texto,slot) {
             textodecoded = Base64.decode(texto);
             partes = textodecoded.split("~");
             pertes = partes[0].split("/");
             var entity = pertes[0];
             var pos = pertes[2];
             pertes = partes[1].split(":");
             var preason = pertes[0];
             var tstamp = pertes[1];


             if(entity=='PAUSECUSTOM' && myposition==pos) {

                tiempos['tick_pausedsince_pause']=parseInt(tstamp)*1000;

                var tDate = new Date();

                var passedvar = {};

                if (typeof(presence[preason]) == 'undefined') {
                    passedvar['PAUSED_COLOR']='#00d020';
                    passedvar['PAUSED_COLOR']='#FFFFFF';
                } else {
                    passedvar['PAUSED_COLOR']=presence[preason];
                }

                if (lang.hasOwnProperty(preason)) {
                    preason = lang[preason];
                }
                if(preason=='ERROR') { preason=''; }

                passedvar['PAUSED_STATUS']=preason;
                passedvar['PAUSED_TIMER']='<span id="tickpause_pausedsince">00:00:00</span>';

                if(preason=='') {
                    delete tiemposdirection['tick_pausedsince_pause'];
                    delete tiempos['tick_pausedsince_pause'];
                    $('#tickpause_pausedsince').text('');
                } else {
                    tiemposdirection['tick_pausedsince_pause']='UP';
                }
                passedvar['LANG']=lang;
                passedvar['NAME']=botonitos[myposition].LABEL;

                console.log(passedvar);
                dust.render("pausedsincepausestatus", passedvar, function(err, out) {
                    $('#pausedsince_paused_status').html(out);
                });

             }
        },
        callback_presence: function(nro,texto,slot) {

            if(nro==myposition) {


                preason = Base64.decode(texto);

                var tDate = new Date();
                tiempos['tick_pausedsince_pause']=tDate.getTime();
                var passedvar = {};

                if (typeof(presence[preason]) == 'undefined') {
                    passedvar['PAUSED_COLOR']='#00d020';
                } else {
                    passedvar['PAUSED_COLOR']=presence[preason];
                }

                if (lang.hasOwnProperty(preason)) {
                    preason = lang[preason];
                }

                passedvar['PAUSED_STATUS']=preason;
                passedvar['PAUSED_TIMER']='<span id="tickpause_pausedsince">00:00:00</span>';

                if(preason=='') {
                    delete tiemposdirection['tick_pausedsince_pause'];
                    delete tiempos['tick_pausedsince_pause'];
                    $('#tickpause_pausedsince').text('');
                } else {
                    tiemposdirection['tick_pausedsince_pause']='UP';
                }
                passedvar['LANG']=lang;
                passedvar['NAME']=botonitos[myposition].LABEL;

                dust.render("pausedsincepausestatus", passedvar, function(err, out) {
                    $('#pausedsince_paused_status').html(out);
                });

                if($('#pause_status_template').length==0) {
                    // not yet rendered as we did not receive lang
                    saved_presence_var = JSON.parse(JSON.stringify(passedvar));
                }
            }
        },
        callback_zbuttons: function() {
            if($('#box_pausedsince').length<=0) {

                var newklon = $('<div class="grid-stack-item" data-gs-height="1" data-gs-width="2" id="box_pausedsince" style="-ms-overflow-style:none;"><div class="grid-stack-item-content handle shadowed pausedsince"><div class="databox bg-white radius-bordered"><div class="databox-left databox-theme-bg"><div id="pausedsince_paused_status">hla</div></div></div></div>');
               grid = $('.grid-stack').data('gridstack');
    
               window.resizinggrid=1;
               if(parseInt(currentrelease.replace(/\./g,''))>23101) {
                   console.log("add new widget pausedsince");
                   grid.addWidget(newklon,0,0,2,2,true);
               } else {
                   grid.add_widget(newklon,0,0,2,2,true);
               }
               window.resizinggrid=0;
            }
            send("<msg data=\"GENERAL|pausedsincegetcustompause|" + myposition + "|\" />");

        },
        init: function() {
            compiled = dust.compile(Base64.decode(pause_status_template),"pausedsincepausestatus");
            dust.loadSource(compiled);
        }
    }
}());
